<?php


namespace Repositories;


use Util\InstanceProvider;

class Paramgeral
{
    public function findParamgeral($fields, $nrOrg)
    {
        $query = <<<SQL
                  SELECT $fields AS "$fields"
                    FROM PARAMGERAL
                   WHERE NRORG = :NRORG
SQL;

        $params = array(
            'NRORG' => $nrOrg
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrOrg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

        $result =  $entityManager->getConnection()->fetchAll($query, $params);
        return !empty($result) ? $result[0] : $result;
    }

    public function findParamgeralWithoutNrorg($nrOrg = NULL )
    {
        $query = <<<SQL
                  SELECT NRORG AS "NRORG"
                    FROM PARAMGERAL
SQL;

        $entityManager = $nrOrg ? InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrOrg) : null;
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

        $result =  $entityManager->getConnection()->fetchAll($query);
        return !empty($result) ? $result[0] : $result;
    }

    public function findPrivacyPolicyPath()
    {
        $query = <<<SQL
                  SELECT DSARQPOLPRIV AS "DSARQPOLPRIV"
                    FROM PARAMGERAL
SQL;

        $entityManager = InstanceProvider::getEntityManager();

        return $entityManager->getConnection()->fetchAll($query);
    }

    public function findPrivacyPolicyPathByAuthentication($nrOrg)
    {
        $query = <<<SQL
                  SELECT DSARQPOLPRIV AS "DSARQPOLPRIV"
                    FROM PARAMGERAL
                   WHERE NRORG = :NRORG
SQL;

        $params = array(
            'NRORG' => $nrOrg
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrOrg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

        $result =  $entityManager->getConnection()->fetchAll($query, $params);
        return !empty($result) ? $result[0] : $result;
    }

    public function updatePrivacyPolicy($dsarqpolpriv, $nrOrg)
    {
        $query = <<<SQL
                  UPDATE PARAMGERAL
                     SET DSARQPOLPRIV = :DSARQPOLPRIV
                   WHERE NRORG = :NRORG
SQL;

        $params = array(
            'NRORG' => $nrOrg,
            'DSARQPOLPRIV' => $dsarqpolpriv
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrOrg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

        return $entityManager->getConnection()->executeQuery($query, $params);
    }

    public function updatePrivacyPolicyClient($dsarqpolprivClie, $nrOrg)
    {
        $query = <<<SQL
                  UPDATE PARAMGERAL
                     SET DSARQPOLPRIVCLIE = :DSARQPOLPRIVCLIE
                   WHERE NRORG = :NRORG
SQL;

        $params = array(
            'NRORG' => $nrOrg,
            'DSARQPOLPRIVCLIE' => $dsarqpolprivClie
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrOrg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

        return $entityManager->getConnection()->executeQuery($query, $params);
    }
}
